
set echo on
set wrap on
col emps format a90
col ordered_emps format a90
break on deptno skip 1

SELECT deptno
,      CAST(
          COLLECT(ename ORDER BY ename) 
             AS varchar2_ntt) AS ordered_emps
FROM   emp
GROUP  BY
       deptno;

CREATE FUNCTION sort_collection (
                p_collection IN varchar2_ntt 
                ) RETURN varchar2_ntt IS
   v_collection varchar2_ntt;
BEGIN
   SELECT column_value 
   BULK   COLLECT INTO v_collection
   FROM   TABLE(p_collection)
   ORDER  BY
          column_value;
   RETURN v_collection;
END sort_collection;
/

SELECT deptno
,      SORT_COLLECTION(
          CAST(COLLECT(ename) AS varchar2_ntt)
          ) AS ordered_emps
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      CAST(
          COLLECT(ename ORDER BY hiredate) 
             AS varchar2_ntt) AS ordered_emps
FROM   emp
GROUP  BY
       deptno;

set serveroutput off
ALTER SESSION SET STATISTICS_LEVEL = ALL;

SELECT e.deptno
,      CAST(
          MULTISET(
             SELECT e2.ename
             FROM   emp e2
             WHERE  e2.deptno = e.deptno
             ORDER  BY
                    e2.hiredate
             ) AS varchar2_ntt) AS ordered_emps
FROM   emp e
GROUP  BY
       e.deptno
ORDER  BY
       e.deptno;

SELECT *
FROM   TABLE(
           XPLAN.DISPLAY_CURSOR(
              NULL, NULL, 'IOSTATS LAST'));

ALTER SESSION SET STATISTICS_LEVEL = BASIC;

set timing on
set autotrace traceonly statistics

SELECT owner
,      object_type
,      CAST(
          COLLECT(object_name ORDER BY object_id) 
             AS varchar2_ntt) AS object_names
FROM   all_objects
GROUP  BY
       owner
,      object_type;

SELECT a.owner
,      a.object_type
,      CAST(
          MULTISET(
             SELECT b.object_name
             FROM   all_objects b
             WHERE  a.owner = b.owner
             AND    a.object_type = b.object_type
             ORDER  BY
                    b.object_id
             ) AS varchar2_ntt) AS object_names
FROM   all_objects a
GROUP  BY
       a.owner
,      a.object_type;

set autotrace off
set timing off

