
set echo on
set wrap on
col jobs format a90
col distinct_jobs format a90
break on deptno skip 1

SELECT deptno
,      CAST(
          COLLECT(DISTINCT job) 
             AS varchar2_ntt) AS distinct_jobs
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      SET(
          CAST(
             COLLECT(job) 
                AS varchar2_ntt)) AS distinct_jobs
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      CAST(
          SET(COLLECT(job))
             AS varchar2_ntt) AS distinct_jobs
FROM   emp
GROUP  BY
       deptno;

SELECT deptno
,      CAST(
          COLLECT(job) 
             AS varchar2_ntt
          ) MULTISET UNION DISTINCT varchar2_ntt() AS distinct_jobs
FROM   emp
GROUP  BY
       deptno;

set timing on
set autotrace traceonly statistics

SELECT owner
,      object_type
,      CAST(
          COLLECT(DISTINCT object_name)
             AS varchar2_ntt) AS object_names
FROM   all_objects
GROUP  BY
       owner
,      object_type;

SELECT owner
,      object_type
,      SET(
          CAST(
             COLLECT(object_name)
                AS varchar2_ntt)) AS object_names
FROM   all_objects
GROUP  BY
       owner
,      object_type;

SELECT owner
,      object_type
,      CAST(
          COLLECT(object_name)
             AS varchar2_ntt
          ) MULTISET UNION DISTINCT varchar2_ntt() AS object_names
FROM   all_objects
GROUP  BY
       owner
,      object_type;

set autotrace off

